<template>
  <div v-if="types == 'addAlbum' || types == 'addEvent'" class="card__item">
    <div class="card__poster add-item" v-wave @click="handleClick">
      <div></div>
    </div>
    <div class="card__date">
      {{ format(new Date(), 'dd MMMM yyyy') }}
    </div>
    <div class="card__title" style="white-space: nowrap">
      <template v-if="types == 'addAlbum'">
        {{ $t('buttons.create_album') }}
      </template>
      <template v-else>
        {{ $t('buttons.create_event') }}
      </template>
    </div>
  </div>
  <div v-else class="card__item">
    <div
      v-wave
      class="card__poster"
      :class="{
        'none-photo': !content.cover
      }"
    >
      <nuxt-link
        v-if="content.id"
        :to="localePath(`${path}${content.id}`)"
      ></nuxt-link>

      <template v-if="content.cover">
        <blur-hash-image
          v-if="content.cover.blurhash"
          :hash="content.cover.blurhash"
          :src="`/storage/${content.cover.preview_url}`"
          class="blurhash"
        />
        <img v-else :src="`/storage/${content.cover.preview_url}`" />
      </template>
      <svg-icon v-else name="photo" />
    </div>
    <div class="card__date">
      <template v-if="content.date">
        {{ format(new Date(content.date), 'dd MMMM yyyy') }}
      </template>
      <template v-else>
        {{ format(new Date(content.created_at), 'dd MMMM yyyy') }}
      </template>
    </div>
    <div class="card__title">
      <nuxt-link
        :to="localePath(`/profile/photography/${path + '/'}${content.id}`)"
      >
        {{ content.name }}
      </nuxt-link>
    </div>

    <div v-if="content.customer" class="card__client">
      <Clients :customer="content.customer" />
    </div>
    <div v-if="content.tags" class="card__tag">
      <span v-for="(item, tagIndex) in content.tags" :key="tagIndex">
        {{ item.tag.tag }}
      </span>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, reactive } from '@nuxtjs/composition-api'
import Avatar from '@/components/ui/Avatar.vue'
import Clients from '@/components/ui/Clients.vue'
import { format } from 'date-fns'

export default defineComponent<{
  types: String
  path: String
  content: Object
}>({
  name: 'Cards',
  props: ['types', 'content', 'path'],
  components: { Avatar, Clients },
  setup(_, { root, emit }) {
    const connectedUser = reactive({
      enabled: root.$accessor.connection.connected
    })
    const handleClick = (event: any) => {
      emit('click', event)
    }
    return {
      connectedUser,
      handleClick,
      format
    }
  }
})
</script>

<style lang="scss" scoped>
.card {
  &__poster {
    height: 280px;
    border-radius: 5px;
    overflow: hidden;
    margin-bottom: 20px;
    font-size: 0px;
    position: relative;

    @media (min-width: 1199.98px) {
      margin-bottom: 20px;
    }

    ::v-deep {
      .blurhash {
        padding-bottom: 280px !important;
        img {
          object-fit: cover;
        }
      }
    }

    > a {
      position: absolute;
      left: 0px;
      right: 0px;
      top: 0px;
      bottom: 0px;
      z-index: 2;
    }
    img {
      width: 100%;
      height: 100%;
      object-fit: cover;
    }
    &.add-item {
      border: 2px solid #474e65;
      border-radius: 10px;
      display: flex;
      align-items: center;
      justify-content: center;
      height: 110px;

      @media (min-width: 1199.98px) {
        height: 280px;
      }

      div {
        width: 37px;
        height: 3px;
        background: #ffffff;
        position: relative;
        &::before {
          content: '';
          position: absolute;
          left: 50%;
          top: 50%;
          transform: translateX(-50%) translateY(-50%);
          height: 37px;
          width: 3px;
          background: #ffffff;
        }
      }
    }
    &.none-photo {
      background: rgba(#7683ad, 0.15);
      border-radius: 10px;
      display: flex;
      align-items: center;
      justify-content: center;
      svg {
        width: 50px;
        height: 50px;
        fill: #00ffb3;
      }
    }
  }
  &__date {
    font-weight: bold;
    color: #7683ad;
    text-transform: uppercase;
    margin-bottom: 5px;
    font-size: 20px;
    line-height: 25px;
    letter-spacing: 1px;
    @media (min-width: 1199.98px) {
      font-size: 18px;
      line-height: 30px;
      letter-spacing: 1.2px;
    }
  }
  &__title {
    font-size: 30px;
    line-height: 30px;
    letter-spacing: 0px;
    color: #ffffff;
    a {
      color: inherit;
      text-decoration: none;
    }
  }
  &__client {
    margin-top: 30px;
  }
  &__tag {
    margin-top: 25px;
    margin-bottom: -15px;
    display: flex;
    align-items: center;
    flex-wrap: wrap;
    span {
      cursor: pointer;
      margin-right: 15px;
      margin-bottom: 15px;
      padding: 4px 15px;
      flex: none;
      background: rgba(#ffffff, 0.1);
      border-radius: 17px;
      text-align: left;
      font-weight: 500;
      font-size: 18px;
      line-height: 25px;
      letter-spacing: 0px;
      color: #ffffff;
      transition: 0.25s all linear;
      &:hover {
        background: #0065ff;
      }
    }
  }
}
</style>
